export default function subscribeAndCount(done, observable, cb) {
    var handleCount = 0;
    var subscription = observable.subscribe({
        next: function (result) {
            try {
                handleCount++;
                cb(handleCount, result);
            }
            catch (e) {
                // Wrap in a `setImmediate` so that we will unsubscribe on the next
                // tick so that we can make sure that the `subscription` has a chance
                // to be defined.
                setImmediate(function () {
                    subscription.unsubscribe();
                    done.fail(e);
                });
            }
        },
        error: done.fail,
    });
    return subscription;
}
//# sourceMappingURL=subscribeAndCount.js.map